import { View, Text, ScrollView } from 'react-native';
import React, { useState } from 'react';
import { useStore } from '../store/store';
import { StatusBar } from 'expo-status-bar';
import BackgroundInfo from "../components/BackgroundInfo";
import { TouchableWithoutFeedback } from 'react-native-gesture-handler';



const Detail = ({navigation, route}: any) => {
  const ItemOfIndex = useStore((state: any) => 
    route.params.type == 'Donut' ? state.AllDonutList1 : state.AllDrinkList1,
  )[route.params.index];
  
  const addToFavoriteList = useStore((state: any) => state.addToFavoriteList);
  const deleteFromFavoriteList = useStore((state: any) => state.deleteFromFavoriteList);

  //favorite functionality
  const ToggleFavorite = (favourite: boolean, type: string, id: string) => {
    favourite ? deleteFromFavoriteList(type, id) : addToFavoriteList(type, id)
  }

  //backhandler functionality
  const BackHandler = () => {
    navigation.pop();
  }

  //desc
  const [descriptionDrink, setDescriptionDrink] = useState(false);

  
  return (
  <View style={{flex: 1, backgroundColor: 'white'}}>
    <StatusBar backgroundColor='dark'/>
    <ScrollView showsVerticalScrollIndicator={false} contentContainerStyle={{flexGrow: 1}}>
      <BackgroundInfo 
        EnableBackHandler={true}
        type={ItemOfIndex.type}
        id={ItemOfIndex.id}
        image_item={ItemOfIndex.image_item}
        favourite={ItemOfIndex.favourite}
        donutname={ItemOfIndex.donutname}
        calories={ItemOfIndex.calories}
        average_rating={ItemOfIndex.average_rating}
        ratings_count={ItemOfIndex.ratings_count}
        BackHandler={BackHandler}
        ToggleFavorite={ToggleFavorite}
      />
      <View style={{padding: 10, marginHorizontal: 10, marginVertical: 10}}>
            {descriptionDrink? (
                <TouchableWithoutFeedback onPress={() => {setDescriptionDrink(prev => !prev)}}>
                    <Text style={{color: 'gray', fontSize: 16}}>{ItemOfIndex.description}</Text>
                </TouchableWithoutFeedback>
                ) : (
                <TouchableWithoutFeedback onPress={() => {setDescriptionDrink(prev => !prev)}}>
                    <Text style={{color: 'gray', fontSize: 16}} numberOfLines={3}>{ItemOfIndex.description}</Text>
                </TouchableWithoutFeedback>
            )}
        </View>
    </ScrollView>
  </View>
  )
}

export default Detail